<?php

$GLOBALS['TL_DCA']['tl_prices_set'] = array
(

	// Config
	'config' => array
	(
		'dataContainer'               => 'Table',
		'ctable'                      => array('tl_prices'),
		'switchToEdit'                => true,
		'enableVersioning'            => true,
		'markAsCopy'                  => 'title',
		//'onload_callback' => array
		//(
		//	array('tl_prices_set', 'checkPermission'),
		//),
		//'oncreate_callback' => array
		//(
		//	array('tl_prices_set', 'adjustPermissions')
		//),
		//'oncopy_callback' => array
		//(
		//	array('tl_prices_set', 'adjustPermissions')
		//),
		'onsubmit_callback' => array
		(
			array('tl_prices_set', 'generateKey'),
		),
		'sql' => array
		(
			'keys' => array
			(
				'id' => 'primary'
			)
		)
	),

	// List
	'list' => array
	(
		'sorting' => array
		(
			'mode'                    => 1,
			'fields'                  => array('title'),
			'flag'                    => 1,
			'panelLayout'             => 'filter;search,limit'
		),
		'label' => array
		(
			'fields'                  => array('title'),
			'format'                  => '%s'
		),
		'global_operations' => array
		(
			'all' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['MSC']['all'],
				'href'                => 'act=select',
				'class'               => 'header_edit_all',
				'attributes'          => 'onclick="Backend.getScrollOffset()" accesskey="e"'
			)
		),
		'operations' => array
		(
			'edit' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_prices_set']['edit'],
				'href'                => 'table=tl_prices',
				'icon'                => 'edit.svg'
			),
			'editheader' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_prices_set']['editheader'],
				'href'                => 'act=edit',
				'icon'                => 'header.svg',
				'button_callback'     => array('tl_prices_set', 'editHeader')
			),
			'copy' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_prices_set']['copy'],
				'href'                => 'act=copy',
				'icon'                => 'copy.svg',
				'button_callback'     => array('tl_prices_set', 'copySet')
			),
			'delete' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_prices_set']['delete'],
				'href'                => 'act=delete',
				'icon'                => 'delete.svg',
				'attributes'          => 'onclick="if(!confirm(\'' . $GLOBALS['TL_LANG']['MSC']['deleteConfirm'] . '\'))return false;Backend.getScrollOffset()"',
				'button_callback'     => array('tl_prices_set', 'deleteSet')
			),
			'show' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_prices_set']['show'],
				'href'                => 'act=show',
				'icon'                => 'show.svg'
			)
		)
	),

	// Palettes
	'palettes' => array
	(
		'__selector__'                => array('protected'),
		'default'                     => '{title_legend},title,currency,config,configHtml;{protected_legend:hide},protected'
	),

	// Subpalettes
	'subpalettes' => array
	(
		'protected'                   => 'groups'
	),

	// Fields
	'fields' => array
	(
		'id' => array
		(
			'sql'                     => "int(10) unsigned NOT NULL auto_increment"
		),
		'tstamp' => array
		(
			'sql'                     => "int(10) unsigned NOT NULL default 0"
		),
		'title' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_prices_set']['title'],
			'exclude'                 => true,
			'search'                  => true,
			'inputType'               => 'text',
			'eval'                    => array('mandatory'=>true, 'maxlength'=>255, 'tl_class'=>'w50'),
			'sql'                     => "varchar(255) NOT NULL default ''"
		),
        'currency' => array
		(
            'label'                   => &$GLOBALS['TL_LANG']['tl_prices']['currency'],
            'exclude'                 => true,
            'inputType'               => 'select',
            'options'                 => $GLOBALS['tourism']['currency']['options'],
            //'options_callback'        => array('tl_prices_set', 'getCurrency'), 
            'eval'                    => array('tl_class' => 'w50'),
            'sql'                     => "varchar(255) NOT NULL default ''"
        ),
        'config' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_prices_set']['config'],
            'exclude' => true,
            'inputType' => 'multiColumnWizard',
            'eval' => array
            (
                'columnFields' => array
                (
                    'headline' => array
                    (
                        'label' => &$GLOBALS['TL_LANG']['tl_prices_set']['config']['headline'],
                        'inputType' => 'text',
                        'eval' => array('mandatory'=>true, 'style'=>'width:100%')
                    ),
                    'key' => array
                    (
                        'label' => &$GLOBALS['TL_LANG']['tl_prices_set']['config']['key'],
                        'inputType' => 'text',
                        'eval' => array('mandatory'=>false, 'style'=>'width:100%'),
						//'save_callback' => array
						//(
						//	array('tl_prices_set', 'generateKey')
						//),
                    )
                ),
                'tl_class'=>'clr',
                'buttons' => array('copy' => false),
            ),
            'sql' => "blob NULL"
        ),
        'configHtml' => array(
        	'input_field_callback'    => array('tl_prices_set', 'configHtmlCallback')
        ),
		'protected' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_prices_set']['protected'],
			'exclude'                 => true,
			'filter'                  => true,
			'inputType'               => 'checkbox',
			'eval'                    => array('submitOnChange'=>true),
			'sql'                     => "char(1) NOT NULL default ''"
		),
		'groups' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_prices_set']['groups'],
			'exclude'                 => true,
			'inputType'               => 'checkbox',
			'foreignKey'              => 'tl_member_group.name',
			'eval'                    => array('mandatory'=>true, 'multiple'=>true),
			'sql'                     => "blob NULL",
			'relation'                => array('type'=>'hasMany', 'load'=>'lazy')
		)
	)
);

/**
 * Provide miscellaneous methods that are used by the data configuration array.
 *
 * @property Contao\Prices $Prices
 */
class tl_prices_set extends Contao\Backend
{

	/**
	 * Import the back end user object
	 */
	public function __construct()
	{
		parent::__construct();
		$this->import('Contao\BackendUser', 'User');
	}

	/**
	 * Check permissions to edit table tl_prices_set
	 *
	 * @throws Contao\CoreBundle\Exception\AccessDeniedException
	 */
	public function checkPermission()
	{
		$bundles = Contao\System::getContainer()->getParameter('kernel.bundles');

		if ($this->User->isAdmin)
		{
			return;
		}

		// Set root IDs
		if (empty($this->User->price) || !\is_array($this->User->price))
		{
			$root = array(0);
		}
		else
		{
			$root = $this->User->price;
		}

		$GLOBALS['TL_DCA']['tl_prices_set']['list']['sorting']['root'] = $root;

		// Check permissions to add sets
		if (!$this->User->hasAccess('create', 'pricesp'))
		{
			$GLOBALS['TL_DCA']['tl_prices_set']['config']['closed'] = true;
			$GLOBALS['TL_DCA']['tl_prices_set']['config']['notCreatable'] = true;
			$GLOBALS['TL_DCA']['tl_prices_set']['config']['notCopyable'] = true;
		}

		// Check permissions to delete calendars
		if (!$this->User->hasAccess('delete', 'pricesp'))
		{
			$GLOBALS['TL_DCA']['tl_prices_set']['config']['notDeletable'] = true;
		}

		/** @var Symfony\Component\HttpFoundation\Session\SessionInterface $objSession */
		$objSession = Contao\System::getContainer()->get('session');

		// Check current action
		switch (Contao\Input::get('act'))
		{
			case 'select':
				// Allow
				break;

			case 'create':
				if (!$this->User->hasAccess('create', 'pricesp'))
				{
					throw new Contao\CoreBundle\Exception\AccessDeniedException('Not enough permissions to create price sets.');
				}
				break;

			case 'edit':
			case 'copy':
			case 'delete':
			case 'show':
				if (!\in_array(Contao\Input::get('id'), $root) || (Contao\Input::get('act') == 'delete' && !$this->User->hasAccess('delete', 'pricesp')))
				{
					throw new Contao\CoreBundle\Exception\AccessDeniedException('Not enough permissions to ' . Contao\Input::get('act') . ' price set ID ' . Contao\Input::get('id') . '.');
				}
				break;

			case 'editAll':
			case 'deleteAll':
			case 'overrideAll':
			case 'copyAll':
				$session = $objSession->all();
				if (Contao\Input::get('act') == 'deleteAll' && !$this->User->hasAccess('delete', 'pricesp'))
				{
					$session['CURRENT']['IDS'] = array();
				}
				else
				{
					$session['CURRENT']['IDS'] = array_intersect((array) $session['CURRENT']['IDS'], $root);
				}
				$objSession->replace($session);
				break;

			default:
				if (\strlen(Contao\Input::get('act')))
				{
					throw new Contao\CoreBundle\Exception\AccessDeniedException('Not enough permissions to ' . Contao\Input::get('act') . ' price sets.');
				}
				break;
		}
	}

	/**
	 * Add the new set to the permissions
	 *
	 * @param $insertId
	 */
	public function adjustPermissions($insertId)
	{
		// The oncreate_callback passes $insertId as second argument
		if (\func_num_args() == 4)
		{
			$insertId = func_get_arg(1);
		}

		if ($this->User->isAdmin)
		{
			return;
		}

		// Set root IDs
		if (empty($this->User->price) || !\is_array($this->User->price))
		{
			$root = array(0);
		}
		else
		{
			$root = $this->User->price;
		}

		// The set is enabled already
		if (\in_array($insertId, $root))
		{
			return;
		}

		/** @var Symfony\Component\HttpFoundation\Session\Attribute\AttributeBagInterface $objSessionBag */
		$objSessionBag = Contao\System::getContainer()->get('session')->getBag('contao_backend');

		$arrNew = $objSessionBag->get('new_records');

		if (\is_array($arrNew['tl_prices_set']) && \in_array($insertId, $arrNew['tl_prices_set']))
		{
			// Add the permissions on group level
			if ($this->User->inherit != 'custom')
			{
				$objGroup = $this->Database->execute("SELECT id, price, pricesp FROM tl_user_group WHERE id IN(" . implode(',', array_map('\intval', $this->User->groups)) . ")");

				while ($objGroup->next())
				{
					$arrNewp = Contao\StringUtil::deserialize($objGroup->pricesp);

					if (\is_array($arrNewp) && \in_array('create', $arrNewp))
					{
						$arrPrices = Contao\StringUtil::deserialize($objGroup->price, true);
						$arrPrices[] = $insertId;

						$this->Database->prepare("UPDATE tl_user_group SET price=? WHERE id=?")
									   ->execute(serialize($arrPrices), $objGroup->id);
					}
				}
			}

			// Add the permissions on user level
			if ($this->User->inherit != 'group')
			{
				$objUser = $this->Database->prepare("SELECT price, pricesp FROM tl_user WHERE id=?")
										   ->limit(1)
										   ->execute($this->User->id);

				$arrNewp = Contao\StringUtil::deserialize($objUser->pricesp);

				if (\is_array($arrNewp) && \in_array('create', $arrNewp))
				{
					$arrPrices = Contao\StringUtil::deserialize($objUser->price, true);
					$arrPrices[] = $insertId;

					$this->Database->prepare("UPDATE tl_user SET price=? WHERE id=?")
								   ->execute(serialize($arrPrices), $this->User->id);
				}
			}

			// Add the new element to the user object
			$root[] = $insertId;
			$this->User->price = $root;
		}
	}


	/**
	 * Return the edit header button
	 *
	 * @param array  $row
	 * @param string $href
	 * @param string $label
	 * @param string $title
	 * @param string $icon
	 * @param string $attributes
	 *
	 * @return string
	 */
	public function editHeader($row, $href, $label, $title, $icon, $attributes)
	{
		return $this->User->canEditFieldsOf('tl_prices_set') ? '<a href="'.$this->addToUrl($href.'&amp;id='.$row['id']).'" title="'.Contao\StringUtil::specialchars($title).'"'.$attributes.'>'.Contao\Image::getHtml($icon, $label).'</a> ' : Contao\Image::getHtml(preg_replace('/\.svg$/i', '_.svg', $icon)).' ';
	}

	/**
	 * Return the copy set button
	 *
	 * @param array  $row
	 * @param string $href
	 * @param string $label
	 * @param string $title
	 * @param string $icon
	 * @param string $attributes
	 *
	 * @return string
	 */
	public function copySet($row, $href, $label, $title, $icon, $attributes)
	{
		return $this->User->hasAccess('create', 'pricesp') ? '<a href="'.$this->addToUrl($href.'&amp;id='.$row['id']).'" title="'.Contao\StringUtil::specialchars($title).'"'.$attributes.'>'.Contao\Image::getHtml($icon, $label).'</a> ' : Contao\Image::getHtml(preg_replace('/\.svg$/i', '_.svg', $icon)).' ';
	}

	/**
	 * Return the delete set button
	 *
	 * @param array  $row
	 * @param string $href
	 * @param string $label
	 * @param string $title
	 * @param string $icon
	 * @param string $attributes
	 *
	 * @return string
	 */
	public function deleteSet($row, $href, $label, $title, $icon, $attributes)
	{
		return $this->User->hasAccess('delete', 'pricesp') ? '<a href="'.$this->addToUrl($href.'&amp;id='.$row['id']).'" title="'.Contao\StringUtil::specialchars($title).'"'.$attributes.'>'.Contao\Image::getHtml($icon, $label).'</a> ' : Contao\Image::getHtml(preg_replace('/\.svg$/i', '_.svg', $icon)).' ';
	}



	public function generateKeyUnique($usedKeys, $string, $index = 0) {

		if($index !== 0) {
			$tmpString = $string.'-'.$index;
		} else {
			$tmpString = $string;
		}

		$generatedKey = Contao\System::getContainer()->get('contao.slug.generator')->generate($tmpString);
		if( !in_array($generatedKey, $usedKeys) ) {
			return $generatedKey;
		} else {
			$index += 1;
			return $this->generateKeyUnique($usedKeys, $string, $index);
		}
	}

	public function generateKey($dc)
	{

		/*
			Maybe this can be easier
			Currently i am looping through all records because i am missing the index key for the $varValue
		*/
		if( is_array($dc->activeRecord->config) ) {
			$config = $dc->activeRecord->config;
		} else {
			$config = unserialize($dc->activeRecord->config);
		}

		$usedKeys = [];
		foreach ($config as $key => $row) {
			if(empty($row['key'])) {
				$generatedKey = $this->generateKeyUnique($usedKeys, $row['headline']);
				array_push($usedKeys, $generatedKey);
				$config[$key]['key'] = $generatedKey;
			} else {
				array_push($usedKeys, $row['key']);
			}
		}

		$config = serialize($config);
		$this->Database->prepare("UPDATE tl_prices_set SET config=? WHERE id=?")->execute(array($config, $dc->activeRecord->id));
	}



    public function configHtmlCallback(DataContainer $dc, $strLabel){

        $return = '';
        $return .= '
            <style>
                table#ctrl_config textarea {
                    max-width: 100% !important;
                }
            </style>
            <div class="clr widget alert"><p>'.$GLOBALS['TL_LANG']['tl_prices_set']['configHtml'].'</p></div>
        ';
        return $return;
    } 
}
